#include <stdio.h>
#include <stdlib.h>

using namespace std;

int main() {
	int n;
	char t;
	char board[1000][1000];

	while (scanf("%d %c", &n, &t) > 0) {
		if (t == 'B') {
			printf("%d\n", n);
			continue;
		}
		else if (t == 'R') {
			printf("%d\n", n);
			continue;
		}

		for (int x = 0; x < n; x++) {
			for (int y = 0; y < n; y++) {
				board[x][y] = 0;
			}
		}

		int team = 1;
		for ( ; ; team++) {
			bool hasZero = false;

			for (int x = 0; x < n; x++) {
				for (int y = 0; y < n; y++) {
					if (board[x][y] != 0) continue;

					bool canPlace = true;

					if (t == 'K') {
						for (int px = x - 2; px <= x + 2; px++) {
							for (int py = y - 2; py <= y + 2; py++) {
								if (px == x && py == y) continue;
								if (px < 0 || px >= n) continue;
								if (py < 0 || py >= n) continue;

								if (board[px][py] == team) canPlace = false;
							}
						}
					}
					else if (t == 'N') {
						for (int px = x - 2; px <= x + 2; px++) {
							for (int py = y - 2; py <= y + 2; py++) {
								if (px == x && py == y) continue;
								if (px < 0 || px >= n) continue;
								if (py < 0 || py >= n) continue;
								if (abs(x - px) * abs(y - py) != 2) continue;
								
								if (board[px][py] == team) canPlace = false;
							}
						}
					}

					if (canPlace) board[x][y] = team;
					else hasZero = true;	
				}
			}


			if (!hasZero) break;
		}
		printf("%d\n", team);
	}

	return 0;
}

